﻿namespace FlickRSearcher.Utility
{
  using System.Windows;
  using System.Windows.Controls;

    public static class BindableVsmState
    {
      public static string GetVsmState(DependencyObject obj)
      {
        return ((string)obj.GetValue(VsmStateProperty));
      }
      public static void SetVsmState(DependencyObject obj, string value)
      {
        obj.SetValue(VsmStateProperty, value);
      }
      public static readonly DependencyProperty VsmStateProperty =
        DependencyProperty.RegisterAttached("VsmStateProperty", typeof(string),
          typeof(BindableVsmState),
          new PropertyMetadata(OnPropertyChanged));

      public static void OnPropertyChanged(DependencyObject sender,
        DependencyPropertyChangedEventArgs args)
      {
        string stateName = args.NewValue as string;
        Control control = sender as Control;

        if (!string.IsNullOrEmpty(stateName) &&
          (control != null))
        {
          VisualStateManager.GoToState(control, stateName, true);
        }
      }
    }
}
