﻿namespace FlickRSearcher.Utility
{
  using System;
  using System.Xml.Linq;

  internal class FlickrPhotoResult
  {
    public FlickrPhotoResult(XElement photo)
    {
      Id = (long)photo.Attribute("id");
      Secret = photo.Attribute("secret").Value;
      Farm = (int)photo.Attribute("farm");
      Server = (int)photo.Attribute("server");
      Title = photo.Attribute("title").Value;
    }
    public long Id { get; private set; }
    public string Secret { get; private set; }
    public int Farm { get; private set; }
    public string Title { get; private set; }
    public int Server { get; private set; }

    public Uri ImageUri
    {
      get
      {
        return (new Uri(string.Format(
          "http://farm{0}.static.flickr.com/{1}/{2}_{3}.jpg",
          Farm, Server, Id, Secret)));
      }
    }
  }
}
