﻿

namespace FlickRSearcher.Utility
{
  using System;
  using System.ComponentModel;
  using System.Reactive.Linq;

  internal static class ObservableEx
  {
    public static IObservable<object> FromPropertyChange(
      this INotifyPropertyChanged propertyChange, string propertyName)
    {
      return (
        Observable
        .FromEventPattern<PropertyChangedEventArgs>(propertyChange, "PropertyChanged")
        .Where(p => p.EventArgs.PropertyName == propertyName)
        .Select(p => p.Sender));
    }
  }
}
