﻿namespace FlickRSearcher.Utility
{
  using System;
  using System.IO;
  using System.Net;
  using System.Reactive.Linq;

  internal static class ObservableWebRequest
  {
    public static IObservable<WebResponse> CreateDeferred(string uri)
    {
      HttpWebRequest request = WebRequest.CreateHttp(uri);

      Func<IObservable<WebResponse>> factory =
        Observable.FromAsyncPattern<WebResponse>(
          request.BeginGetResponse, request.EndGetResponse);

      return (Observable.Defer(factory));
    }
  }
}