﻿namespace FlickRSearcher.Utility
{
  using System;
  using System.Windows.Input;

  public class SimpleCommand : ICommand
  {
    public event EventHandler CanExecuteChanged;

    public SimpleCommand(Action action)
    {
      this.action = action;
      this.canExecute = true;
    }
    public SimpleCommand(Action<object> paramAction)
    {
      this.paramAction = paramAction;
      this.canExecute = true;
    }
    public void Execute(object parameter)
    {
      if (this.action != null)
      {
        this.action();
      }
      else
      {
        this.paramAction(parameter);
      }
    }
    public void SetCanExecute(bool canExecute)
    {
      this.canExecute = canExecute;

      if (this.CanExecuteChanged != null)
      {
        this.CanExecuteChanged(this, EventArgs.Empty);
      }
    }
    public bool CanExecute(object parameter)
    {
      return (this.canExecute);
    }        
    bool canExecute;
    Action action;
    Action<object> paramAction;
  }
}