﻿namespace FlickRSearcher.Utility
{
  using System.Reflection;
  using System.Windows;
  using System.Windows.Data;
  using System.Windows.Interactivity;

  public class UpdateSourceAction : TriggerAction<FrameworkElement>
  {
    public string BoundPropertyName { get; set; }
    BindingExpression binding;

    protected override void OnAttached()
    {
      base.OnAttached();

      if ((this.AssociatedObject != null) &&
        (!string.IsNullOrEmpty(this.BoundPropertyName)))
      {
        FieldInfo fi =
          base.AssociatedObject.GetType().GetField(this.BoundPropertyName,
            BindingFlags.Static | BindingFlags.Public);

        if (fi != null)
        {
          DependencyProperty dependencyProperty =
            fi.GetValue(this.AssociatedObject) as DependencyProperty;

          if (dependencyProperty != null)
          {
            this.binding =
              base.AssociatedObject.GetBindingExpression(dependencyProperty);
          }
        }
      }
    }
    protected override void OnDetaching()
    {
      base.OnDetaching();
      this.binding = null;
    }
    protected override void Invoke(object parameter)
    {
      if (this.binding != null)
      {
        this.binding.UpdateSource();
      }
    }
  }
}