﻿namespace FlickRSearcher.Utility
{
  using System;
  using System.IO;
  using System.Net;
  using System.Reactive.Linq;

  internal static class WebResponseExtensions
  {
    public static Stream ReadResponseToMemoryStream(this WebResponse response)
    {
      MemoryStream ms = new MemoryStream();

      using (response)
      {
        using (Stream stream = response.GetResponseStream())
        {
          stream.CopyTo(ms);
          ms.Seek(0, SeekOrigin.Begin);
        }
        response.Close();
      }
      return (ms);
    }
  }
}
