﻿namespace FlickRSearcher
{
  using System;
  using System.Text;
  using System.Windows;
  using System.Windows.Controls;

  public partial class ErrorWindow : ChildWindow
  {
    public static void ShowException(Exception ex)
    {
      StringBuilder builder = new StringBuilder();
      Exception currentEx = ex;

      while (currentEx != null)
      {
        builder.AppendLine(ex.Message);
        builder.Append("\tat ");
        builder.AppendLine(ex.StackTrace);
        currentEx = currentEx.InnerException;
      }
      ErrorWindow window = new ErrorWindow(builder.ToString());
      window.HorizontalAlignment = HorizontalAlignment.Center;
      window.Show();
    }
    public ErrorWindow(string text)
    {
      InitializeComponent();
      this.ErrorText = text;
      this.DataContext = this;
    }
    public string ErrorText { get; private set; }
  }
}